Bug 60175 - AOT mis-compiles when coverage is used
Summary: AOT mis-compiles when coverage is used
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: AOT (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: --- normal
Target Milestone: ---
Assignee: Zoltan Varga
URL:
Depends on:
Blocks:
 
Reported: 2017-10-13 10:09 UTC by Marek Safar
Modified: 2017-11-07 02:22 UTC (History)
2 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Marek Safar 2017-10-13 10:09:54 UTC
using System;


class X
{
    public static void Main ()
    {
        "string".Replace ("abcd", "xyz");
    }
}

1. csc foo.cs -debug
2. mono --profile=coverage --aot --debug foo.exe
3. mono --debug foo.exe

You get NRE crash

System.NullReferenceException: Object reference not set to an instance of an object
  at X.Main () [0x00000] in foo3.cs:7
Comment 1 Zoltan Varga 2017-10-13 14:28:33 UTC
We probably shouldn't support aot+coverage right now.
Comment 2 Marek Safar 2017-10-13 14:36:25 UTC
I am ok if we abort with some error message
Comment 3 Marek Safar 2017-10-13 14:37:00 UTC
Thinking about it, does not profiling have the same problem?
Comment 4 Zoltan Varga 2017-10-27 03:23:10 UTC
Profiling doesn't change the generated code, we do ip based sampling.
Comment 5 Zoltan Varga 2017-10-27 03:26:53 UTC
https://github.com/mono/mono/pull/5881
Comment 6 Zoltan Varga 2017-11-07 02:22:07 UTC
Fixed.